import brl.blitz
import "entity.bmx"
import "prop.bmx"
import "score.bmx"
TCar^TEntity{
TOP_SPEED#=0.325#
STEER_CHANGE#=0.0958#
AI_STEER_CHANGE#=0.07#
STEER_RETURN_FACTOR#=0.9935#
MAX_STEER#=10#
BRAKE#=0.0006#
IDLE_BRAKE#=4e-05#
GEARS%=5
PLAYER_Z%=5
MIN_FRONT_WHEEL_OFFSET_Y#=10#
MAX_FRONT_WHEEL_OFFSET_Y#=30#
SLOPE_TO_FRONT_WHEEL_DY_FACTOR%=80
MAX_FRONT_WHEEL_DY_FACTOR%=5
AI_MAX_SPEED_DECREASE#=0.039#
TARGET_X_MARGIN%=50
CAR_WIDTH%=180
CAR_LENGTH#=0.8#
MAX_DISTANCE_FROM_CENTER%=1600
SIDE_BUMP_MIN_DISTANCE%=280
SIDE_BUMP_MAX_DISTANCE%=360
OFFROAD_BUMP_MIN_DISTANCE%=460
SIDE_BUMP_TIME%=4
SIDE_BUMP_SLOWDOWN#=0.00012#
OFFROAD_BUMP_SLOWDOWN#=0.006#
MIN_SLOWDOWN_SPEED#=0.13#
MAX_APPLIED_DRIFT#=10#
MAX_EXHAUST_FLASH_TIME%=5000
MIN_EXHAUST_FLASH_TIME%=100
GOLDEN_COLOR_TIME%=15
DAMAGE_SMOKING%=3
SMOKING_TIME%=700
SMOKE_TIME%=20
GRID_SIZE%=8
GRID_PLAYER_POS%=7
GRID_STEP_Z#=2.4#
GRID_START_Z#=19.4#
PLAYER_CAR_COLOR_GREEN%=0
PLAYER_CAR_COLOR_YELLOW%=1
PLAYER_CAR_COLOR_RED%=2
PLAYER_CAR_COLOR_BLACK%=3
gGfxWheelFront:TImage&=mem:p("_bb_TCar_gGfxWheelFront")
gGfxWheelRear:TImage&=mem:p("_bb_TCar_gGfxWheelRear")
gGfxShadow:TImage&=mem:p("_bb_TCar_gGfxShadow")
gGfxExhaustFlash:TImage&=mem:p("_bb_TCar_gGfxExhaustFlash")
gSndEngine1:TSound&=mem:p("_bb_TCar_gSndEngine1")
gSndEngine2:TSound&=mem:p("_bb_TCar_gSndEngine2")
gSndBump:TSound&=mem:p("_bb_TCar_gSndBump")
gSndGrassBump:TSound&=mem:p("_bb_TCar_gSndGrassBump")
gSndSkid:TSound&=mem:p("_bb_TCar_gSndSkid")
gSndExplosion:TSound&=mem:p("_bb_TCar_gSndExplosion")
gSndExhaustFlash:TSound&=mem:p("_bb_TCar_gSndExhaustFlash")
gSndPlok:TSound&=mem:p("_bb_TCar_gSndPlok")
gSndCrash:TSound&=mem:p("_bb_TCar_gSndCrash")
gWheelFrontWidth%&=mem("_bb_TCar_gWheelFrontWidth")
gWheelFrontHeight%&=mem("_bb_TCar_gWheelFrontHeight")
gWheelRearWidth%&=mem("_bb_TCar_gWheelRearWidth")
gWheelRearHeight%&=mem("_bb_TCar_gWheelRearHeight")
gNewestEnemy:TCar&=mem:p("_bb_TCar_gNewestEnemy")
gNextEnemyZ:TCar&=mem:p("_bb_TCar_gNextEnemyZ")
gEnemyCount%&=mem("_bb_TCar_gEnemyCount")
gEnemyMinZ#&=mem:f("_bb_TCar_gEnemyMinZ")
.fChnEngine1:TChannel&
.fChnEngine2:TChannel&
.fChnSkid:TChannel&
.fHuman%&
.fSpeed#&
.fAccFactor#&
.fSteer#&
.fSteerResult#&
.fDX#&
.fOutwardForce#&
.fColorR%&
.fColorG%&
.fColorB%&
.fSideBumpTime#&
.fLeftWheelBump%&
.fRightWheelBump%&
.fTargetSpeedFactor#&
.fTargetSpeed#&
.fTargetX#&
.fDistanceToPlayer#&
.fWheelColor#&
.fSlope#&
.fInTunnel%&
.fSoundRateModifier#&
.fJumping%&
.fJumpDY#&
.fJumpY#&
.fWingWidthModifier#&
.fWingYOffsetModifier#&
.fAICollisionWarning%&
.fDrift#&
.fDriftFraction#&
.fDrawRearLWheelX#&
.fDrawRearRWheelX#&
.fExhaustFlashTimer%&
.fExhaustFlashScale#&
.fGolden%&
.fGoldenColorTimer%&
.fDamage%&
.fSmokingTimer%&
.fSmokeTimer%&
.fScoreCounted%&
.fSteerChange#&
.fSteerReturnFactor#&
.fTopSpeed#&
.fMaxSteer#&
-New%()="_bb_TCar_New"
-Delete%()="_bb_TCar_Delete"
+Create:TCar(pZ#,pX#,pHuman%=0,pPlayerCarColor%=2)="_bb_TCar_Create"
+removeAll%()="_bb_TCar_removeAll"
+loadGraphics%()="_bb_TCar_loadGraphics"
+loadSounds%()="_bb_TCar_loadSounds"
+createStartingGrid:TCar(pPlayerCarColor%)="_bb_TCar_createStartingGrid"
-updateEngineSound%()="_bb_TCar_updateEngineSound"
-setSegmentDX%(pSegmentDX#,pSegmentDXFraction#)="_bb_TCar_setSegmentDX"
-update%(pDZ#)="_bb_TCar_update"
-updateWheelColor%()="_bb_TCar_updateWheelColor"
-updateSmoking%()="_bb_TCar_updateSmoking"
-checkCollisions%(pLookAhead%=0)="_bb_TCar_checkCollisions"
-deactivate%()="_bb_TCar_deactivate"
-draw%()="_bb_TCar_draw"
-drawWheel%(pGfx:TImage,pX#,pY#,pWidth%,pHeight%)="_bb_TCar_drawWheel"
-drawShadow%()="_bb_TCar_drawShadow"
-getSpeed#()="_bb_TCar_getSpeed"
-isHuman%()="_bb_TCar_isHuman"
-isCar%()="_bb_TCar_isCar"
-receiveHit#(pSpeed#,pZ#,pLength#)="_bb_TCar_receiveHit"
-selectNewLane%(pBlockedX#)="_bb_TCar_selectNewLane"
-setSlope%(pSlope#)="_bb_TCar_setSlope"
-setInTunnel%(pInTunnel%)="_bb_TCar_setInTunnel"
-clear%()="_bb_TCar_clear"
}="bb_TCar"
