import brl.blitz
import "aspect.bmx"
import "constants.bmx"
import "segment.bmx"
import "car.bmx"
import "cloud.bmx"
import "horizon.bmx"
TGameMode^Object{
STATE_TITLE%=0
STATE_START%=1
STATE_ACTION%=2
STATE_GAME_OVER%=3
START_COUNT_DOWN%=300
START_COUNT_DOWN_REPEATS%=4
CHECKPOINT_TIME_FIRST_LAP%=90
CHECKPOINT_TIME_BONUS_1%=80
CHECKPOINT_TIME_BONUS_2%=70
CHECKPOINT_TIME_BONUS_3%=60
NEW_PLAYER_CAR_TIME%=3
GAME_OVER_FADE_SPEED#=0.005#
CLOUD_COUNT%=10
BUSH_COUNT_AT_START%=20
MIN_ENEMY_TIME%=20
MAX_ENEMY_TIME%=140
MAX_ENEMY_COUNT%=5
LAP_COUNT_BRONZE%=6
LAP_COUNT_SILVER%=7
LAP_COUNT_GOLD%=8
TROPHY_NONE%=-1
TROPHY_BRONZE%=0
TROPHY_SILVER%=1
TROPHY_GOLD%=2
gGfxRoad:TImage&=mem:p("_bb_TGameMode_gGfxRoad")
gGfxTrophies:TImage&=mem:p("_bb_TGameMode_gGfxTrophies")
gGfxSelectCar:TImage&=mem:p("_bb_TGameMode_gGfxSelectCar")
gGfxSelectCarRect:TImage&=mem:p("_bb_TGameMode_gGfxSelectCarRect")
gFont32:TImageFont&=mem:p("_bb_TGameMode_gFont32")
gFont64:TImageFont&=mem:p("_bb_TGameMode_gFont64")
gSndTitleMusic:TSound&=mem:p("_bb_TGameMode_gSndTitleMusic")
gSndRaceMusic:TSound&=mem:p("_bb_TGameMode_gSndRaceMusic")
gSndLap:TSound&=mem:p("_bb_TGameMode_gSndLap")
gSndStart1:TSound&=mem:p("_bb_TGameMode_gSndStart1")
gSndStart2:TSound&=mem:p("_bb_TGameMode_gSndStart2")
gChnMusic:TChannel&=mem:p("_bb_TGameMode_gChnMusic")
gState%&=mem("_bb_TGameMode_gState")
gZMap#&[]&=mem:p("_bb_TGameMode_gZMap")
gScale#&[]&=mem:p("_bb_TGameMode_gScale")
gPlayer:TCar&=mem:p("_bb_TGameMode_gPlayer")
gPlayerX#&=mem:f("_bb_TGameMode_gPlayerX")
gPlayerSegmentDX#&=mem:f("_bb_TGameMode_gPlayerSegmentDX")
gPlayerSpeed#&=mem:f("_bb_TGameMode_gPlayerSpeed")
gEnemyTimer#&=mem:f("_bb_TGameMode_gEnemyTimer")
gEnemyLane%&=mem("_bb_TGameMode_gEnemyLane")
gBushTimer#&=mem:f("_bb_TGameMode_gBushTimer")
gHorizon1:THorizon&=mem:p("_bb_TGameMode_gHorizon1")
gHorizon2:THorizon&=mem:p("_bb_TGameMode_gHorizon2")
gHorizon3:THorizon&=mem:p("_bb_TGameMode_gHorizon3")
gHorizonYOffset#&=mem:f("_bb_TGameMode_gHorizonYOffset")
gTextureOffset#&=mem:f("_bb_TGameMode_gTextureOffset")
gStartCountDown%&=mem("_bb_TGameMode_gStartCountDown")
gStartCountDownRepeats%&=mem("_bb_TGameMode_gStartCountDownRepeats")
gGameOverAlpha#&=mem:f("_bb_TGameMode_gGameOverAlpha")
gCheckpointTimer%&=mem("_bb_TGameMode_gCheckpointTimer")
gNewPlayerCarTimer%&=mem("_bb_TGameMode_gNewPlayerCarTimer")
gTime%&=mem("_bb_TGameMode_gTime")
gLaps%&=mem("_bb_TGameMode_gLaps")
gPlayerDistance#&=mem:f("_bb_TGameMode_gPlayerDistance")
gWindowed%&=mem("_bb_TGameMode_gWindowed")
gTrophy%&=mem("_bb_TGameMode_gTrophy")
gMusicEnabled%&=mem("_bb_TGameMode_gMusicEnabled")
gSelectedMusic:TSound&=mem:p("_bb_TGameMode_gSelectedMusic")
gPlayerCarColor%&=mem("_bb_TGameMode_gPlayerCarColor")
-New%()="_bb_TGameMode_New"
-Delete%()="_bb_TGameMode_Delete"
+init%()="_bb_TGameMode_init"
+resetGraphics%()="_bb_TGameMode_resetGraphics"
+loadGraphics%()="_bb_TGameMode_loadGraphics"
+initZMapAndScaling%()="_bb_TGameMode_initZMapAndScaling"
+playMusic%(pMusic:TSound,pChannel:TChannel)="_bb_TGameMode_playMusic"
+stopMusic%()="_bb_TGameMode_stopMusic"
+toggleMusic%()="_bb_TGameMode_toggleMusic"
+switchToState%(pState%)="_bb_TGameMode_switchToState"
+createClouds%()="_bb_TGameMode_createClouds"
+createBushes%()="_bb_TGameMode_createBushes"
+createHorizons%()="_bb_TGameMode_createHorizons"
+removeAllGameObjects%()="_bb_TGameMode_removeAllGameObjects"
+removeHorizons%()="_bb_TGameMode_removeHorizons"
+update%()="_bb_TGameMode_update"
+updateBushTimer%(pSpeed#)="_bb_TGameMode_updateBushTimer"
+updateEnemyTimer%(pSpeed#)="_bb_TGameMode_updateEnemyTimer"
+updateTextureOffset%(pSpeed#)="_bb_TGameMode_updateTextureOffset"
+updateHorizons%(pSpeed#)="_bb_TGameMode_updateHorizons"
+draw%()="_bb_TGameMode_draw"
+drawHUD%()="_bb_TGameMode_drawHUD"
+drawHorizons%()="_bb_TGameMode_drawHorizons"
}="bb_TGameMode"
